#include <Profiles/BicycleSpeed/DataPages/Base/ANTPLUS_BicycleSpeedBaseMainDataPageMsg.h>
#include <Profiles/BicycleSpeed/ANTPLUS_BicycleSpeedPrivateDefines.h>
#include <ANTPLUS_PrivateDefines.h>

BicycleSpeedBaseMainDataPageMsg::BicycleSpeedBaseMainDataPageMsg(uint8_t dataPageNumber) : BaseDataPageMsg<BroadcastDataMsg>() {
    setDataBuffer(_buffer);
    _buffer[ANTPLUS_DEFAULT_DATAPAGE_BYTE] = dataPageNumber;
}

uint8_t BicycleSpeedBaseMainDataPageMsg::getPageChangeToggle() {
    return (_buffer[ANTPLUS_BICYCLESPEED_DATAPAGEBASE_TOGGLE_BYTE] & ANTPLUS_BICYCLESPEED_DATAPAGEBASE_TOGGLE_MASK) >> ANTPLUS_BICYCLESPEED_DATAPAGEBASE_TOGGLE_SHIFT;
}

uint16_t BicycleSpeedBaseMainDataPageMsg::getBikeSpeedEventTime() {
    return (_buffer[ANTPLUS_BICYCLESPEED_DATAPAGEBASE_BIKESPEEDEVENTTIMEMSB_BYTE] << ANTPLUS_BICYCLESPEED_DATAPAGEBASE_BIKESPEEDEVENTTIMEMSB_SHIFT) | _buffer[ANTPLUS_BICYCLESPEED_DATAPAGEBASE_BIKESPEEDEVENTTIMELSB_BYTE];
}

uint16_t BicycleSpeedBaseMainDataPageMsg::getCumulativeSpeedRevolutionCount() {
    return (_buffer[ANTPLUS_BICYCLESPEED_DATAPAGEBASE_CUMULATIVESPEEDREVOLUTIONCOUNTMSB_BYTE] << ANTPLUS_BICYCLESPEED_DATAPAGEBASE_CUMULATIVESPEEDREVOLUTIONCOUNTMSB_SHIFT) | _buffer[ANTPLUS_BICYCLESPEED_DATAPAGEBASE_CUMULATIVESPEEDREVOLUTIONCOUNTLSB_BYTE];
}

void BicycleSpeedBaseMainDataPageMsg::setPageChangeToggle(uint8_t toggle) {
    _buffer[ANTPLUS_BICYCLESPEED_DATAPAGEBASE_TOGGLE_BYTE] = _buffer[ANTPLUS_BICYCLESPEED_DATAPAGEBASE_TOGGLE_BYTE] & ~ANTPLUS_BICYCLESPEED_DATAPAGEBASE_TOGGLE_MASK;
    _buffer[ANTPLUS_BICYCLESPEED_DATAPAGEBASE_TOGGLE_BYTE] |= toggle ? ANTPLUS_BICYCLESPEED_DATAPAGEBASE_TOGGLE_MASK : 0;
}

void BicycleSpeedBaseMainDataPageMsg::setBikeSpeedEventTime(uint16_t time) {
    _buffer[ANTPLUS_BICYCLESPEED_DATAPAGEBASE_BIKESPEEDEVENTTIMEMSB_BYTE] = time >> ANTPLUS_BICYCLESPEED_DATAPAGEBASE_BIKESPEEDEVENTTIMEMSB_SHIFT;
    _buffer[ANTPLUS_BICYCLESPEED_DATAPAGEBASE_BIKESPEEDEVENTTIMELSB_BYTE] = time & ANTPLUS_DEFAULT_BYTE_MASK;
}

void BicycleSpeedBaseMainDataPageMsg::setCumulativeSpeedRevolutionCount(uint16_t count) {
    _buffer[ANTPLUS_BICYCLESPEED_DATAPAGEBASE_CUMULATIVESPEEDREVOLUTIONCOUNTMSB_BYTE] = count >> ANTPLUS_BICYCLESPEED_DATAPAGEBASE_CUMULATIVESPEEDREVOLUTIONCOUNTMSB_SHIFT;
    _buffer[ANTPLUS_BICYCLESPEED_DATAPAGEBASE_CUMULATIVESPEEDREVOLUTIONCOUNTLSB_BYTE] = count & ANTPLUS_DEFAULT_BYTE_MASK;
}
